=== debian/changelog ===
xiphos (4.2.1+dfsg1-5~mx19+1) mx; urgency=medium

  * Rebuild for MX Linux.

 -- Steven Pusser <stevep@mxlinux.org>  Wed, 13 Jan 2021 09:23:39 -0800

xiphos (4.2.1+dfsg1-5) unstable; urgency=medium

  * updated standards version
  * new upload to unstable with depends on sword 1.9

 -- Teus Benschop <teusbenschop@debian.org>  Sat, 28 Nov 2020 20:45:30 +0100

xiphos (4.2.1+dfsg1-4) experimental; urgency=medium

  * depend on sword 1.9

 -- Teus Benschop <teusbenschop@debian.org>  Sat, 21 Nov 2020 16:52:29 +0100

xiphos (4.2.1+dfsg1-3) unstable; urgency=medium

  [ Bastian Germann ]
  * Team upload.
  * Guarantee image display fallback (Closes: #969775)

  [ Teus Benschop ]
  * d/control: Fix uploader email

 -- Teus Benschop <teusbenschop@debian.org>  Sat, 21 Nov 2020 16:20:15 +0100

xiphos (4.2.1+dfsg1-2) unstable; urgency=medium

  [ Bastian Germann ]
  * d/changelog: Correct bug link
  * Don't compress .ogg files (Closes: #913128)

 -- Teus Benschop <teusbenschop@debian.org>  Sun, 12 Jul 2020 19:55:21 +0200

xiphos (4.2.1+dfsg1-1) unstable; urgency=medium

  [ Daniel Glassey ]
  * d/control remove Unit 193 from uploaders on his request

  [ Dimitri John Ledkov ]
  * Drop myself from uploaders.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use versioned copyright format URI.
  * Bump debhelper from old 11 to 12.

  [ Bastian Germann ]
  * Drop waf for next version
  * d/copyright: Drop undefined Upstream-Source
  * Replace gnome-doc-utils with yelp (Closes: #947542)
  * Replace waf with cmake (Closes: #922784)
  * Change Build-Depends to new version's requirements
  * Add patch: Override git version
  * Drop and refresh patches
  * Fix install locations
  * Update debhelper version (13)
  * Do not build epub
  * lintian: rules-requires-root-missing
  * lintian: debug-symbol-migration-possibly-complete
  * lintian: debian-rules-uses-as-needed-linker-flag
  * Set Standards-Version: 4.5.0
  * Don't install other md files
  * no shlibs on all pkg
  * d/copyright: Add missing info
  * d/control: Suggest festival
  * Add patch: CMake: Don't include win32
  * Disable postinst target

  [ Teus Benschop ]
  * New upstream version 4.2.1+dfsg1 (Closes: #964098)

 -- Teus Benschop <teusbenschop@debian.org>  Sat, 04 Jul 2020 16:44:06 +0200
