=== debian/rules ===
#!/usr/bin/make -f

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DEPUB=OFF -DPOSTINST=OFF

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_compress:
	dh_compress --exclude=.ogg

override_dh_strip:
	dh_strip --no-automatic-dbgsym
