=== src/main/CMakeLists.txt ===
--- 
+++ 
@@ -60,6 +60,7 @@
   PkgConfig::Core
   PkgConfig::Gtk
   PkgConfig::Gnome
+  PkgConfig::Soup
   PkgConfig::Sword
   PkgConfig::Biblesync
   )
@@ -71,6 +72,18 @@
   PkgConfig::Core
   PkgConfig::Gtk
   PkgConfig::Gnome
+  PkgConfig::Soup
   PkgConfig::Sword
   PkgConfig::Biblesync
   )
+
+if(WK_FOUND)
+  target_compile_definitions(main
+    PRIVATE
+    PkgConfig::WK
+    )
+  target_link_libraries(main
+    PRIVATE
+    PkgConfig::WK
+    )
+endif()
